/*
 * Created on Oct 31, 2003
 */
package isac.util.formulae;

import java.io.Serializable;

/**
 * @author rgradisc
 */

public class Specification implements Serializable {

    protected CalcHeadSimpleID theory_;

    protected KEStoreID problem_, method_;

    public String toSMLString() {
        StringBuffer sb = new StringBuffer();
        sb.append(getTheory().getQuotedID());
        sb.append(",");
        sb.append(getProblem().toSMLString());
        sb.append(",");
        sb.append(getMethod().toSMLString());
        return sb.toString();
    }

    public CalcHeadSimpleID getTheory() {
        return theory_;
    }

    public KEStoreID getMethod() {
        return method_;
    }

    public KEStoreID getProblem() {
        return problem_;//(ProblemID)problem_ ---> ClassCastException LK?
    }

    public void setTheory(CalcHeadSimpleID el) {
        theory_ = el;
    }

    public void setProblem(KEStoreID el) {
        problem_ = el;
    }

    public void setMethod(KEStoreID el) {
        method_ = el;
    }

    //WN0505 this stems from a misunderstanding in 03!
    public String toString() {
        String content = "<SPECIFICATION>\n";
        if (theory_ != null) {
            content += "<THEORY>\n" + theory_ + "</THEORY>\n";
        }
        if (problem_ != null)
        //FIXME MK really meant like this?
                content += "<PROBLME>\n" + problem_ + "</PROBLEM>\n";
        if (method_ != null) content += "<METHOD>\n" + method_ + "</METHOD>\n";
        content += "</SPECIFICATION>\n";
        return content;
    }
}